/*

We add attacking. The other mobs wander freely unless
they have a target. They don't actively acquire targets,
they will only target a mob when they are attacked.

To attack a mob, click on it when you're standing next to it.

*/

mob
	Click()
		if(get_dist(src, usr) <= 1)
			usr.attack(src)

	// We add a stat panel to show every AI mob and its target.
	Stat()
		stat(src)

		for(var/mob/ai/m in world)
			stat(" ")
			stat("AI mob", m)
			stat("target", m.target)

mob
	proc
		ai()

		// hit_by is called when a mob attacks you. src is the mob that
		// was attacked and m is the mob that attacked src. The default
		// behavior of the proc is to do nothing, but we can define a
		// different behavior for AI-controlled mobs.
		hit_by(mob/m)

		// attack is called when one mob attacks another. src is the mob
		// that is attacking and target is the mob being attacked.
		attack(mob/target)
			show_hit(target)
			target.hit_by(src)

	Login()
		. = ..()
		icon_state = "green"

	ai
		var
			mob/target

		New()
			..()
			spawn(rand(10,20)) ai()

		ai()
			// If the mob has a target we should attack it (if we're
			// in range) or move towards it if we aren't.
			if(target)
				if(get_dist(src, target) > 1)
					step_to(src, target)
				else
					attack(target)

			// If the mob has no target it should just wander randomly.
			else
				step_rand(src)

			spawn(10) ai()

		// You might not always want the AI loop to have the
		// same delay. If the mob is chasing after its target
		// you might want it to move faster. If the mob is
		// wandering you might want a longer delay.
		// Try this version of the ai proc and see the difference:
		/*
		ai()
			if(target)
				if(get_dist(src, target) > 1)
					step_to(src, target)
					sleep(5)
				else
					attack(target)
					sleep(10)
			else
				step_rand(src)
				sleep(20)

			spawn() ai()
		*/

		// When an AI-controlled mob is attacked, it targets the mob
		// that attacked it.
		hit_by(mob/m)
			if(!target)
				target = m

		red
			icon_state = "red"
		blue
			icon_state = "blue"