/*

In this example the red mob will target anyone who
gets within two tiles of it. The blue mobs still only
fight back when attacked.


  -- When you run this example --

When you run this example see what happens when you move
near the red mob. Restart the game, then try to avoid the
red mob until a blue mob moves near it. Once the red mob
begins to attack the blue mob you can safely move near it.

*/

mob
	Click()
		if(get_dist(src, usr) <= 1)
			usr.attack(src)

	Stat()
		stat(src)

		for(var/mob/ai/m in world)
			stat(" ")
			stat("AI mob", m)
			stat("target", m.target)
mob
	proc
		ai()
		hit_by(mob/m)
		attack(mob/target)
			show_hit(target)
			target.hit_by(src)

	Login()
		. = ..()
		icon_state = "green"

	ai
		var
			mob/target

		New()
			..()
			spawn(rand(10,20)) ai()

		ai()
			if(target)
				if(get_dist(src, target) > 1)
					step_to(src, target)
					sleep(5)
				else
					attack(target)
					sleep(10)
			else
				// We try to acquire a target. If we get a target we
				// have a short delay before the next AI cycle. If we
				// don't get a target we continue wandering.
				get_target()
				if(target)
					sleep(5)
				else
					step_rand(src)
					sleep(20)

			spawn() ai()

		hit_by(mob/m)
			if(!target)
				target = m

		proc
			get_target()

		red
			icon_state = "red"

			// get_target is responsible for setting the target variable.
			get_target()
				for(var/mob/m in oview(2, src))
					target = m
					return

		blue
			icon_state = "blue"

			// Because the blue mob doesn't define a get_target function
			// it uses the default behavior, which does nothing and always
			// returns null.