/*

In this example we add teams. Each mob has a team
variable that is a number. If two mobs are on the
same team their team variables will have the same
value. We can compare these values so that mobs on
the same team don't attack each other.

Red mobs are still aggressive, but will only attack
mobs that aren't on their team. AI mobs will ignore
attacks made against them by mobs on their team.

Try changing the value of team for each mob (red, blue,
and the player) and see what happens.

*/

// We use these constants to define the teams.
var
	const
		TEAM_1 = 1
		TEAM_2 = 2
		TEAM_3 = 3

mob
	Click()
		if(get_dist(src, usr) <= 1)
			usr.attack(src)

	Stat()
		stat(src)
		stat("team", team)

		for(var/mob/ai/m in world)
			stat(" ")
			stat("AI mob", m)
			stat("team", m.team)
			stat("target", m.target)

mob
	var
		team = 0
	proc
		ai()
		hit_by(mob/m)
		attack(mob/target)
			show_hit(target)
			target.hit_by(src)

	Login()
		. = ..()
		team = TEAM_1
		icon_state = "green"

	ai
		var
			mob/target

		New()
			..()
			spawn(rand(10,20)) ai()

		ai()
			if(target)
				if(get_dist(src, target) > 1)
					step_to(src, target)
					sleep(5)
				else
					attack(target)
					sleep(10)
			else
				get_target()
				if(target)
					sleep(5)
				else
					step_rand(src)
					sleep(20)

			spawn() ai()

		hit_by(mob/m)
			// The mobs assume that attacks made against them
			// by a teammate must have been an accident, so
			// they ignore these attacks. This doesn't have to
			// be the case. Comment out this line and teammates
			// can turn on each other!
			if(m.team == team) return

			if(!target)
				target = m

		proc
			get_target()

		red
			team = TEAM_2
			icon_state = "red"

			// We update get_target() to check the team of each potential target.
			get_target()
				for(var/mob/m in oview(2, src))
					if(m.team != team)
						target = m
						return

		blue
			team = TEAM_2
			icon_state = "blue"