/*

The solution to exercise 1-1 builds on the code from code-06.dm.

Scroll to the bottom for the solution.

*/

var
	const
		TEAM_1 = 1
		TEAM_2 = 2
		TEAM_3 = 3

mob
	Click()
		if(get_dist(src, usr) <= 1)
			usr.attack(src)

	Stat()
		stat(src)
		stat("team", team)

		for(var/mob/ai/m in world)
			stat(" ")
			stat("AI mob", m)
			stat("team", m.team)
			stat("target", m.target)

mob

	var
		team = 0
		power = 0
		health = 0

	proc
		ai()
		hit_by(mob/m)
		attack(mob/target)
			show_hit(target)
			target.hit_by(src)

	Login()
		. = ..()

		power = 20
		health = 50

		team = TEAM_1
		icon_state = "green"

	ai
		var
			mob/target

		New()
			..()
			spawn(rand(10,20)) ai()

		ai()
			if(target)
				// Even if we have a target we want to be on the lookout for
				// new targets. If the new target is more desirable then our
				// current target we'll switch to it.
				get_target()

				call_for_help()
				if(get_dist(src, target) > 1)
					step_to(src, target)
					sleep(5)
				else
					attack(target)
					sleep(10)
			else
				get_target()
				if(target)
					sleep(5)
				else
					step_rand(src)
					sleep(20)

			spawn() ai()

		hit_by(mob/m)
			// We can use the new change_target proc to decide if
			// we should change to target the mob that attacked us.
			change_target(m)

		proc
			get_target()

			call_for_help()

			// This is the default behavior for change_target, the red and blue
			// mobs define their own behavior. This default behavior matches our
			// old behavior, mobs only take the new target if they didn't already
			// have a target
			change_target(mob/m)
				// To avoid runtime errors we need to make sure that m isn't null
				if(!m) return

				// We don't want the mobs to ever target a mob on their team.
				if(m.team == team) return

				// If we already have a target, ignore the new target
				if(target) return

				target = m

		red
			power = 30
			health = 40
			team = TEAM_2
			icon_state = "red"

			// Because we are now prioritizing targets we don't want
			// to target the first non-teammate within 2 tiles. A simple
			// way to use the new change_target proc is to have the red
			// mob try to change its target to every mob within two tiles.
			// In the end, its target will be the most desirable one.
			get_target()
				for(var/mob/m in oview(2, src))
					change_target(m)

			change_target(mob/m)
				if(!m) return

				// We still want to ignore teammates
				if(m.team == team) return

				// If we didn't have a target, take the new target
				if(!target)
					target = m
					return

				// Only take the new target if it's more powerful
				// than our old target
				if(m.power > target.power)
					target = m

		blue
			power = 10
			health = 30

			team = TEAM_1
			icon_state = "blue"

			call_for_help()
				for(var/mob/ai/m in oview(5, src))
					if(m.team == team)
						m.change_target(target)

			change_target(mob/m)
				if(!m) return

				// We still want to ignore teammates
				if(m.team == team) return

				// If we didn't have a target, take the new target
				if(!target)
					target = m
					return

				// Only take the new target if it has less health
				// than our old target
				if(m.health < target.health)
					target = m

// ---- The code below this line was added as the solution for exercise 1-1 ----

		crazy
			// These two settings don't really matter.
			team = TEAM_1
			icon_state = "purple"

			// We don't need to use the ai proc from /mob/ai, we want our
			// crazy mob to always call step_rand.
			ai()
				step_rand(src)
				spawn(3) ai()

// This will automatically place the crazy mob on the map for this demo.
mob
	Login()
		..()
		new /mob/ai/crazy(locate(9,10,1))